#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

static const int root = 0;

int main(int argc, char *argv[]) {
  int sz, me;

  MPI_Init(&argc, &argv);

  MPI_Comm_size(MPI_COMM_WORLD, &sz);
  MPI_Comm_rank(MPI_COMM_WORLD, &me);

  {
    int size = sz, i;
    int *array = (int *)malloc(size * sizeof(int));

    if (me == root) {
      for (i = 0; i < size; i++)
        array[i] = i * i;
    } else {
      for (i = 0; i < size; i++)
        array[i] = -1;
    }

    MPI_Scatter(array, 1, MPI_INT, array, 1, MPI_INT, root, MPI_COMM_WORLD);

    printf("At %d:", me);
    for (i = 0; i < size; i++)
      printf(" %d", array[i]);
    printf("\n");

    array[0] += me + 1;
    
    if (argc == 1)
      MPI_Gather(array, 1, MPI_INT, array, 1, MPI_INT, root, MPI_COMM_WORLD);
    else
      MPI_Allgather(array, 1, MPI_INT, array, 1, MPI_INT, MPI_COMM_WORLD);
    
    printf("Final at %d:", me);
    for (i = 0; i < size; i++)
      printf(" %d", array[i]);
    printf("\n");
  }

  MPI_Finalize();
}
