#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

int main(int argc, char *argv[]) {
  int sz, me;

  MPI_Init(&argc, &argv);

  MPI_Comm_size(MPI_COMM_WORLD, &sz);
  MPI_Comm_rank(MPI_COMM_WORLD, &me);

  {
    int size = 1;
    int *array = (int *)malloc(size * sizeof(int));

    if (me == 0) {
      MPI_Request req;
      MPI_Status s;

      array[0] = 42;
      MPI_Isend(array, size, MPI_INT, 1, 8, MPI_COMM_WORLD, &req);
      printf("sending %d...\n", array[0]);

      MPI_Wait(&req, &s);
      printf("send complete\n");
    } else {
      MPI_Request req;
      MPI_Status s;

      MPI_Irecv(array, size, MPI_INT, 0, 8, MPI_COMM_WORLD, &req);
      printf("getting...\n");

      MPI_Wait(&req, &s);
      printf("get complete %d\n", array[0]);
    }
  }

  MPI_Finalize();
}
