#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <mpi.h>

int main(int argc, char *argv[]) {
  int sz, me;

  MPI_Init(&argc, &argv);

  MPI_Comm_size(MPI_COMM_WORLD, &sz);
  MPI_Comm_rank(MPI_COMM_WORLD, &me);

  {
    int size = 1;
    int *array = (int *)malloc(size * sizeof(int));

    if (me == 0) {
      MPI_Request *reqs;
      MPI_Status s;
      int i, which;

      reqs = (MPI_Request *)malloc((sz - 1) * sizeof(MPI_Request));
      array[0] = 42;
      
      for (i = 1; i < sz; i++) {
        MPI_Isend(array, size, MPI_INT, i, 8, MPI_COMM_WORLD, &reqs[i-1]);
        printf("sending %d to %d...\n", array[0], i);
      }

      for (i = 1; i < sz; i++) {
        MPI_Waitany(sz - 1, reqs, &which, &s);
        printf("send complete for %d\n", which + 1);
      }
    } else {
      MPI_Request req;
      MPI_Status s;

      printf("getting at %d...\n", me);
      MPI_Irecv(array, size, MPI_INT, 0, 8, MPI_COMM_WORLD, &req);

      MPI_Wait(&req, &s);
      printf("get complete at %d: %d\n", me, array[0]);
    }
  }

  MPI_Finalize();
}
