#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <mpi.h>

int main(int argc, char *argv[]) {
  int sz, me, root;

  MPI_Init(&argc, &argv);

  MPI_Comm_size(MPI_COMM_WORLD, &sz);
  MPI_Comm_rank(MPI_COMM_WORLD, &me);

  root = sz - 1;

  {
    int size = 1;
    int *array = (int *)malloc(size * sizeof(int));

    if (me == root) {
      MPI_Request *reqs;
      MPI_Status s;
      int i, which;

      reqs = (MPI_Request *)malloc((sz - 1) * sizeof(MPI_Request));
      array[0] = 42;
      
      for (i = 0; i < sz - 1; i++) {
        MPI_Isend(array, size, MPI_INT, i, 8, MPI_COMM_WORLD, &reqs[i]);
        printf("sending %d to %d...\n", array[0], i);
      }

      while (1) {
        printf("still waiting:");
        for (i = 0; i < sz - 1; i++) {
          if (reqs[i] != MPI_REQUEST_NULL)
            printf(" %d", i);
        }
        printf("\n");
        
        MPI_Waitany(sz - 1, reqs, &which, &s);
        if (which == MPI_UNDEFINED)
            break;

        printf("send complete for %d\n", which);
      }
    } else {
      MPI_Request req;
      MPI_Status s;

      MPI_Irecv(array, size, MPI_INT, root, 8, MPI_COMM_WORLD, &req);
      printf("getting at %d...\n", me);

      MPI_Wait(&req, &s);
      printf("get complete at %d: %d\n", me, array[0]);
    }
  }

  MPI_Finalize();
}
