#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

#define MY_TAG 8

int main(int argc, char *argv[]) {
  int sz, me;

  MPI_Init(&argc, &argv);

  MPI_Comm_size(MPI_COMM_WORLD, &sz);
  MPI_Comm_rank(MPI_COMM_WORLD, &me);

  {
    int size = 1;
    int *array = (int *)malloc(size * sizeof(int));

    if (me == 0) {
      array[0] = 42;
      MPI_Send(array, size, MPI_INT, 1, MY_TAG, MPI_COMM_WORLD);
      printf("sent %d\n", array[0]);
    } else {
      MPI_Status s;
      MPI_Recv(array, size, MPI_INT, 0, MY_TAG, MPI_COMM_WORLD, &s);
      printf("got %d\n", array[0]);
    }
  }

  MPI_Finalize();
}
